import java.util.*;
void reorder(int[][] data) {
    // sort pages
    Arrays.sort(data, new Comparator<int[]>() {
        @Override
        public int compare(int[] o1, int[] o2) {
            float sum1 = 0;
            for (int i = 0; i < o1.length - 1; ++i) {
                sum1 += o1[i];
            }
            sum1 = sum1 / (o1.length-1);

            float sum2 = 0;
            for (int i = 0; i < o2.length - 1; ++i) {
                sum2 += o2[i];
            }
            sum2 = sum2 / (o2.length-1);
            return Float.compare(sum1, sum2);
        }
    });
    // sort dewey
    int[][] tempdata = transposeArr(data);
    Arrays.sort(tempdata, new Comparator<int[]>() {
        @Override
        public int compare(int[] o1, int[] o2) {
            float sum1 = 0;
            for (int i = 0; i < o1.length - 1; ++i) {
                sum1 += o1[i];
            }
            sum1 = sum1 / (o1.length-1);

            float sum2 = 0;
            for (int i = 0; i < o2.length - 1; ++i) {
                sum2 += o2[i];
            }
            sum2 = sum2 / (o2.length-1);
            return Float.compare(sum1, sum2);
        }
    });
    arrayCopy(transposeArr(tempdata), data);
}

int[][] transposeArr(int[][] arr) {
    int ilen = arr.length;
    int jlen = arr[0].length;
    int[][] newarr = new int[jlen][ilen];
    for (int i = 0; i < ilen; ++i) {
        for (int j = 0; j < jlen; ++j) {
            newarr[j][i] = arr[i][j];
        }
    }
    return newarr;
}
